using CallCenterApi.DB;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CallCenterApi.DAL
{
    /// <summary>
    /// 数据访问类:T_Bus_People
    /// </summary>
    public partial class T_Bus_People
    {
        public T_Bus_People()
        { }
        #region  BasicMethod

        /// <summary>
        /// 得到最大ID
        /// </summary>
        public int GetMaxId()
        {
            return DbHelperSQL.GetMaxID("F_ID", "T_Bus_People");
        }

        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int F_ID)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Bus_People");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ID", SqlDbType.Int,4)
            };
            parameters[0].Value = F_ID;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(CallCenterApi.Model.T_Bus_People model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Bus_People(");
            strSql.Append("tid,forumName,subject,nickName,typeName,domainName,stateInfo,dateline,videoImgUrl,videoUrl,videoDuration,content,threadsCheckTime,realName,phone,remark,aid,attachment,topicMainTitle,F_WorkOrderId,state)");
            strSql.Append(" values (");
            strSql.Append("@tid,@forumName,@subject,@nickName,@typeName,@domainName,@stateInfo,@dateline,@videoImgUrl,@videoUrl,@videoDuration,@content,@threadsCheckTime,@realName,@phone,@remark,@aid,@attachment,@topicMainTitle,@F_WorkOrderId,@state)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@tid", SqlDbType.Decimal,9),
                    new SqlParameter("@forumName", SqlDbType.NVarChar,50),
                    new SqlParameter("@subject", SqlDbType.NVarChar,500),
                    new SqlParameter("@nickName", SqlDbType.NVarChar,500),
                    new SqlParameter("@typeName", SqlDbType.NVarChar,500),
                    new SqlParameter("@domainName", SqlDbType.NVarChar,500),
                    new SqlParameter("@stateInfo", SqlDbType.NVarChar,50),
                    new SqlParameter("@dateline", SqlDbType.DateTime),
                    new SqlParameter("@videoImgUrl", SqlDbType.NVarChar,1000),
                    new SqlParameter("@videoUrl", SqlDbType.NVarChar,1000),
                    new SqlParameter("@videoDuration", SqlDbType.Int,4),
                    new SqlParameter("@content", SqlDbType.NVarChar,-1),
                    new SqlParameter("@threadsCheckTime", SqlDbType.DateTime),
                    new SqlParameter("@realName", SqlDbType.NVarChar,50),
                    new SqlParameter("@phone", SqlDbType.NVarChar,50),
                    new SqlParameter("@remark", SqlDbType.NVarChar,-1),
                    new SqlParameter("@aid", SqlDbType.NVarChar,50),
                    new SqlParameter("@attachment", SqlDbType.Int,4),
                    new SqlParameter("@topicMainTitle", SqlDbType.NVarChar,500),
                    new SqlParameter("@F_WorkOrderId", SqlDbType.VarChar,500),
            new SqlParameter("@state", SqlDbType.Int )};
            parameters[0].Value = model.tid;
            parameters[1].Value = model.forumName;
            parameters[2].Value = model.subject;
            parameters[3].Value = model.nickName;
            parameters[4].Value = model.typeName;
            parameters[5].Value = model.domainName;
            parameters[6].Value = model.stateInfo;
            parameters[7].Value = model.dateline;
            parameters[8].Value = model.videoImgUrl;
            parameters[9].Value = model.videoUrl;
            parameters[10].Value = model.videoDuration;
            parameters[11].Value = model.content;
            parameters[12].Value = model.threadsCheckTime;
            parameters[13].Value = model.realName;
            parameters[14].Value = model.phone;
            parameters[15].Value = model.remark;
            parameters[16].Value = model.aid;
            parameters[17].Value = model.attachment;
            parameters[18].Value = model.topicMainTitle;
            parameters[19].Value = model.F_WorkOrderId;
            parameters[20].Value = model.state;
            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(CallCenterApi.Model.T_Bus_People model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Bus_People set ");
            strSql.Append("tid=@tid,");
            strSql.Append("forumName=@forumName,");
            strSql.Append("subject=@subject,");
            strSql.Append("nickName=@nickName,");
            strSql.Append("typeName=@typeName,");
            strSql.Append("domainName=@domainName,");
            strSql.Append("stateInfo=@stateInfo,");
            strSql.Append("dateline=@dateline,");
            strSql.Append("videoImgUrl=@videoImgUrl,");
            strSql.Append("videoUrl=@videoUrl,");
            strSql.Append("videoDuration=@videoDuration,");
            strSql.Append("content=@content,");
            strSql.Append("threadsCheckTime=@threadsCheckTime,");
            strSql.Append("realName=@realName,");
            strSql.Append("phone=@phone,");
            strSql.Append("remark=@remark,");
            strSql.Append("aid=@aid,");
            strSql.Append("attachment=@attachment,");
            strSql.Append("topicMainTitle=@topicMainTitle,");
            strSql.Append("state=@state,");
            strSql.Append("F_WorkOrderId=@F_WorkOrderId");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@tid", SqlDbType.Decimal,9),
                    new SqlParameter("@forumName", SqlDbType.NVarChar,50),
                    new SqlParameter("@subject", SqlDbType.NVarChar,500),
                    new SqlParameter("@nickName", SqlDbType.NVarChar,500),
                    new SqlParameter("@typeName", SqlDbType.NVarChar,500),
                    new SqlParameter("@domainName", SqlDbType.NVarChar,500),
                    new SqlParameter("@stateInfo", SqlDbType.NVarChar,50),
                    new SqlParameter("@dateline", SqlDbType.DateTime),
                    new SqlParameter("@videoImgUrl", SqlDbType.NVarChar,1000),
                    new SqlParameter("@videoUrl", SqlDbType.NVarChar,1000),
                    new SqlParameter("@videoDuration", SqlDbType.Int,4),
                    new SqlParameter("@content", SqlDbType.NVarChar,-1),
                    new SqlParameter("@threadsCheckTime", SqlDbType.DateTime),
                    new SqlParameter("@realName", SqlDbType.NVarChar,50),
                    new SqlParameter("@phone", SqlDbType.NVarChar,50),
                    new SqlParameter("@remark", SqlDbType.NVarChar,-1),
                    new SqlParameter("@aid", SqlDbType.NVarChar,50),
                    new SqlParameter("@attachment", SqlDbType.Int,4),
                    new SqlParameter("@topicMainTitle", SqlDbType.NVarChar,500),
                    new SqlParameter("@state", SqlDbType.Int,4),
                    new SqlParameter("@F_WorkOrderId", SqlDbType.VarChar,500),
                    new SqlParameter("@F_ID", SqlDbType.Int,4)};
            parameters[0].Value = model.tid;
            parameters[1].Value = model.forumName;
            parameters[2].Value = model.subject;
            parameters[3].Value = model.nickName;
            parameters[4].Value = model.typeName;
            parameters[5].Value = model.domainName;
            parameters[6].Value = model.stateInfo;
            parameters[7].Value = model.dateline;
            parameters[8].Value = model.videoImgUrl;
            parameters[9].Value = model.videoUrl;
            parameters[10].Value = model.videoDuration;
            parameters[11].Value = model.content;
            parameters[12].Value = model.threadsCheckTime;
            parameters[13].Value = model.realName;
            parameters[14].Value = model.phone;
            parameters[15].Value = model.remark;
            parameters[16].Value = model.aid;
            parameters[17].Value = model.attachment;
            parameters[18].Value = model.topicMainTitle;
            parameters[19].Value = model.state;
            parameters[20].Value = model.F_WorkOrderId;
            parameters[21].Value = model.F_ID;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_ID)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Bus_People ");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ID", SqlDbType.Int,4)
            };
            parameters[0].Value = F_ID;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_IDlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Bus_People ");
            strSql.Append(" where F_ID in (" + F_IDlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Bus_People GetModel(int F_ID)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_ID,tid,forumName,subject,nickName,typeName,domainName,stateInfo,dateline,videoImgUrl,videoUrl,videoDuration,content,threadsCheckTime,realName,phone,remark,aid,attachment,topicMainTitle,F_WorkOrderId,state from T_Bus_People ");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ID", SqlDbType.Int,4)
            };
            parameters[0].Value = F_ID;

            CallCenterApi.Model.T_Bus_People model = new CallCenterApi.Model.T_Bus_People();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Bus_People DataRowToModel(DataRow row)
        {
            CallCenterApi.Model.T_Bus_People model = new CallCenterApi.Model.T_Bus_People();
            if (row != null)
            {
                if (row["F_ID"] != null && row["F_ID"].ToString() != "")
                {
                    model.F_ID = int.Parse(row["F_ID"].ToString());
                }
                if (row["tid"] != null && row["tid"].ToString() != "")
                {
                    model.tid = decimal.Parse(row["tid"].ToString());
                }
                if (row["forumName"] != null)
                {
                    model.forumName = row["forumName"].ToString();
                }
                if (row["subject"] != null)
                {
                    model.subject = row["subject"].ToString();
                }
                if (row["nickName"] != null)
                {
                    model.nickName = row["nickName"].ToString();
                }
                if (row["typeName"] != null)
                {
                    model.typeName = row["typeName"].ToString();
                }
                if (row["domainName"] != null)
                {
                    model.domainName = row["domainName"].ToString();
                }
                if (row["stateInfo"] != null)
                {
                    model.stateInfo = row["stateInfo"].ToString();
                }
                if (row["dateline"] != null && row["dateline"].ToString() != "")
                {
                    model.dateline = DateTime.Parse(row["dateline"].ToString());
                }
                if (row["videoImgUrl"] != null)
                {
                    model.videoImgUrl = row["videoImgUrl"].ToString();
                }
                if (row["videoUrl"] != null)
                {
                    model.videoUrl = row["videoUrl"].ToString();
                }
                if (row["videoDuration"] != null && row["videoDuration"].ToString() != "")
                {
                    model.videoDuration = int.Parse(row["videoDuration"].ToString());
                }
                if (row["content"] != null)
                {
                    model.content = row["content"].ToString();
                }
                if (row["threadsCheckTime"] != null && row["threadsCheckTime"].ToString() != "")
                {
                    model.threadsCheckTime = DateTime.Parse(row["threadsCheckTime"].ToString());
                }
                if (row["realName"] != null)
                {
                    model.realName = row["realName"].ToString();
                }
                if (row["phone"] != null)
                {
                    model.phone = row["phone"].ToString();
                }
                if (row["remark"] != null)
                {
                    model.remark = row["remark"].ToString();
                }
                if (row["aid"] != null)
                {
                    model.aid = row["aid"].ToString();
                }
                if (row["attachment"] != null && row["attachment"].ToString() != "")
                {
                    model.attachment = int.Parse(row["attachment"].ToString());
                }
                if (row["topicMainTitle"] != null)
                {
                    model.topicMainTitle = row["topicMainTitle"].ToString();
                }
                if (row["F_WorkOrderId"] != null)
                {
                    model.F_WorkOrderId = row["F_WorkOrderId"].ToString();
                }
                if (row["state"] != null && row["state"].ToString() != "")
                {
                    model.state = int.Parse(row["state"].ToString());
                }
                
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_ID,tid,forumName,subject,nickName,typeName,domainName,stateInfo,dateline,videoImgUrl,videoUrl,videoDuration,content,threadsCheckTime,realName,phone,remark,aid,attachment,topicMainTitle,F_WorkOrderId,state ");
            strSql.Append(" FROM T_Bus_People ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" F_ID,tid,forumName,subject,nickName,typeName,domainName,stateInfo,dateline,videoImgUrl,videoUrl,videoDuration,content,threadsCheckTime,realName,phone,remark,aid,attachment,topicMainTitle,F_WorkOrderId,state ");
            strSql.Append(" FROM T_Bus_People ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Bus_People ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_ID desc");
            }
            strSql.Append(")AS Row, T.*  from T_Bus_People T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /*
		/// <summary>
		/// 分页获取数据列表
		/// </summary>
		public DataSet GetList(int PageSize,int PageIndex,string strWhere)
		{
			SqlParameter[] parameters = {
					new SqlParameter("@tblName", SqlDbType.VarChar, 255),
					new SqlParameter("@fldName", SqlDbType.VarChar, 255),
					new SqlParameter("@PageSize", SqlDbType.Int),
					new SqlParameter("@PageIndex", SqlDbType.Int),
					new SqlParameter("@IsReCount", SqlDbType.Bit),
					new SqlParameter("@OrderType", SqlDbType.Bit),
					new SqlParameter("@strWhere", SqlDbType.VarChar,1000),
					};
			parameters[0].Value = "T_Bus_People";
			parameters[1].Value = "F_ID";
			parameters[2].Value = PageSize;
			parameters[3].Value = PageIndex;
			parameters[4].Value = 0;
			parameters[5].Value = 0;
			parameters[6].Value = strWhere;	
			return CallCenterApi.RunProcedure("UP_GetRecordByPage",parameters,"ds");
		}*/

        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod
    }
}
